#include <iostream>
using namespace std;

#define MAX_POW 20
#define MAX_VAL (1 << MAX_POW)

// Usage: dp[ log(bound) ][ height ]
long dp[MAX_POW][MAX_VAL];

long calc(int width, int height) {
	if(width == 0) return 0;
	int max_pow = 0;
	while((1 << max_pow) < width) max_pow++;

	int bound = 1 << max_pow;
	if(width == bound) return dp[max_pow][height];
	return dp[max_pow - 1][height] + calc(width - bound / 2, height);
}

/**
 * Lessons
 *  - Don't leave debug statements in submission
 *  - Dynamic programming
 *  - Large global lookup table
 *  - Calculate one, poll many times
 *  - Actually calculate complextiy before submitting
 *  - Bit manipulation
 */
int main() {
	for(int bound_exp = 0; bound_exp < MAX_POW; bound_exp++) {
		int bound = (1 << bound_exp);
		for(int height = 0; height < MAX_VAL; height++) {
			if(bound == 1) {
				dp[bound_exp][height] = height;
			} else {
				int blocks = height / bound;
				int excess = height - bound * blocks;
				dp[bound_exp][height] = blocks + 2 * dp[bound_exp - 1][excess];
			}
		}
	}

	int T;
	cin >> T;
	for(int test_case = 0; test_case < T; test_case++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;

		int width_bound = MAX_VAL, height_bound = MAX_VAL;
		int width_mid = width_bound / 2, height_mid = height_bound / 2;
		while(true) {
			if(a > width_mid) {
				a -= width_mid;
				b -= width_mid;
				width_bound = width_mid;
			} else if(b <= width_mid) {
				width_bound = width_mid;
			} else if(c > height_mid) {
				c -= height_mid;
				d -= height_mid;
				height_bound = height_mid;
			} else if(d <= height_mid) {
				height_bound = height_mid;
			} else {
				break;
			}

			width_mid = width_bound / 2;
			height_mid = height_bound / 2;
		}

		if(a == 0) {
			a += width_mid;
			b += width_mid;
		} else if(b == width_bound) {
			b = width_mid + width_bound - a;
			a = width_mid;
		}

		if(c == 0) {
			c += height_mid;
			d += height_mid;
		} else if(d == height_bound) {
			d = height_mid + height_bound - c;
			c = height_mid;
		}

		int x, y;
		long result = 0;

		x = b - width_mid, y = d - height_mid;
		result += calc(x, y);
		x = b - width_mid, y = height_mid - c;
		result += calc(x, y);
		x = width_mid - a, y = d - height_mid;
		result += calc(x, y);
		x = width_mid - a, y = height_mid - c;
		result += calc(x, y);

		cout << result << '\n';
	}

	return 0;
}

